#ifndef _adf4113_h_
#define _adf4113_h_

void adf4113_config(void);

#define ADF4113_L0_CTL		0
#define ADF4113_L0_REFCNT_SHIFT	2
#define ADF4113_L0_APB1		((unsigned long)1 << 16)
#define ADF4113_L0_APB2		((unsigned long)1 << 17)

#define ADF4113_L1_CTL		1
#define ADF4113_L1_A_SHIFT	2
#define ADF4113_L1_B_SHIFT	8
#define ADF4113_L1_LD_PREC	((unsigned long)1 << 22)

#define ADF4113_L2_CTL		2
#define ADF4113_L2_CTR_RESET	(1 << 2)
#define ADF4113_L2_PWRDN	(1 << 3)
#define ADF4113_L2_MUXOUT_HIZ	(0 << 4)
#define ADF4113_L2_MUXOUT_DLD	(1 << 4)
#define ADF4113_L2_MUXOUT_NDIV	(2 << 4)
#define ADF4113_L2_MUXOUT_HIGH	(3 << 4)
#define ADF4113_L2_MUXOUT_RDIV	(4 << 4)
#define ADF4113_L2_MUXOUT_ALD	(5 << 4)
#define ADF4113_L2_MUXOUT_SDO	(6 << 4)
#define ADF4113_L2_MUXOUT_LOW	(7 << 4)
#define ADF4113_L2_PD_POL	(1 << 7)
#define ADF4113_L2_CP_HIZ	(8 << 7)
#define ADF4113_L2_CPC_80	((unsigned long)0 << 15)
#define ADF4113_L2_CPC_160	((unsigned long)1 << 15)
#define ADF4113_L2_CPC_240	((unsigned long)2 << 15)
#define ADF4113_L2_CPC_320	((unsigned long)3 << 15)
#define ADF4113_L2_CPC_400	((unsigned long)4 << 15)
#define ADF4113_L2_CPC_480	((unsigned long)5 << 15)
#define ADF4113_L2_CPC_560	((unsigned long)6 << 15)
#define ADF4113_L2_CPC_640	((unsigned long)7 << 15)
#define ADF4113_L2_PRE_8_9	((unsigned long)0 << 22)	
#define ADF4113_L2_PRE_16_17	((unsigned long)1 << 22)	
#define ADF4113_L2_PRE_32_33	((unsigned long)2 << 22)	
#define ADF4113_L2_PRE_64_65	((unsigned long)3 << 22)	

#define ADF4113_CLK		0x04
#define ADF4113_CLK_POUT	P1OUT
#define ADF4113_CLK_PDIR	P1DIR
#define ADF4113_DATA		0x01
#define ADF4113_DATA_POUT	P1OUT
#define ADF4113_DATA_PDIR	P1DIR
#define ADF4113_LE		0x10
#define ADF4113_LE_POUT		P2OUT
#define ADF4113_LE_PDIR		P2DIR

#endif
